extends Camera2D

export (float) var min_zoom = 1
export (float) var max_zoom = 16
export (int) var pan_speed = 20
export (float) var zoom_speed = 0.4

var pan_velocity = Vector2()
var zoom_velocity: float = 0.0

func move(v: Vector2):
	self.global_position.x += (v.x * self.zoom.x)
	self.global_position.y += (v.y * self.zoom.y)

func change_zoom(v: float):
	if (self.zoom.x + v) < min_zoom:
		_set_zoom(min_zoom)
		return
	if (self.zoom.x + v) > max_zoom:
		_set_zoom(max_zoom)
		return
	_set_zoom(self.zoom.x + v)

func _set_zoom(v: float):
	self.zoom.x = v
	self.zoom.y = v

func get_input():
	pan_velocity = Vector2()
	zoom_velocity = 0.0
	if Input.is_action_pressed('ui_right'):
		pan_velocity.x += 1
	if Input.is_action_pressed('ui_left'):
		pan_velocity.x -= 1
	if Input.is_action_pressed('ui_down'):
		pan_velocity.y += 1
	if Input.is_action_pressed('ui_up'):
		pan_velocity.y -= 1
	if Input.is_action_pressed('zoom_in') or Input.is_action_just_released("zoom_in"):
		zoom_velocity -= 1
	if Input.is_action_pressed('zoom_out') or Input.is_action_just_released("zoom_out"):
		zoom_velocity += 1
	if pan_velocity.x != 0.0 || pan_velocity.y != 0.0:
		print("Register press: ", pan_velocity)
	pan_velocity = pan_velocity.normalized() * pan_speed
	zoom_velocity = zoom_velocity * zoom_speed

func _physics_process(_delta):
	if _delta > 0.02:
		print(_delta)
	get_input()
	if pan_velocity.length() != 0.0:
		self.move(pan_velocity)
	if zoom_velocity != 0.0:
		self.change_zoom(zoom_velocity)
